﻿using System.Text.Json.Serialization;
using RPG.GameCore.Enums;
using RPG.GameCore.Excel.Attributes;
using RPG.GameCore.Types;

namespace RPG.GameCore.Excel;

[ExcelTable("MapEntryExcelTable.json", ExcelType.MapEntry)]
public class MapEntryRow : ExcelRow
{
    public override uint Id => ID;

    public uint ID { get; set; } // 0x10
    public bool IsShowInMapMenu { get; set; } // 0x14
    public uint MapMenuSortID { get; set; } // 0x18
    [JsonConverter(typeof(JsonStringEnumConverter))]
    public MapEntryType EntranceType { get; set; } // 0x1C
    public uint EntranceGroupID { get; set; } // 0x20
    public TextID Name { get; set; } // 0x24
    public TextID Desc { get; set; } // 0x28
    public string? EntranceListIcon { get; set; } // 0x30
    public string? ImagePath { get; set; } // 0x38
    public uint[] MiniMapIconHintList { get; set; } = []; // 0x40
    public uint ShowReward { get; set; } // 0x48
    public uint PlaneID { get; set; } // 0x4C
    public uint FloorID { get; set; } // 0x50
    public uint StartGroupID { get; set; } // 0x54
    public uint StartAnchorID { get; set; } // 0x58
    public uint TargetMission { get; set; } // 0x5C
    public uint[] TargetMainMissionList { get; set; } = []; // 0x60
    public uint[] BeginMainMissionList { get; set; } = []; // 0x68
    public uint[] FinishMainMissionList { get; set; } = []; // 0x70
    public uint[] FinishQuestList { get; set; } = []; // 0x78
    public uint UnlockQuest { get; set; } // 0x80
}
