using RPG.Services.MUIP.Handlers;
using RPG.Services.Core.Extensions;
using RPG.Services.MUIP.Network.Command;

namespace RPG.Services.MUIP;

internal static class Program
{
    private static async Task Main(string[] args)
    {
        Console.Title = "KafkaSR | MUIP";

        WebApplicationBuilder builder = WebApplication.CreateBuilder(args);
        builder.WebHost.UseUrls("http://*:1337");
        builder.SetupRPGService<RPGMuipserver, MuipserverCommandHandler>(true);

        WebApplication app = builder.Build();

        app.MapGet("/api/gmtalk", ApiHandler.OnGmTalk);

        await app.RunAsync();
    }
}
